// Macro for aligning two stacks A and B and saving them
// Bottom slice of stack A and top slice of stack B are aligned
// Author: Dr. Kedar Khare, IIT Delhi

stackA = "C:\\Users\\Kedar\\Desktop\\3D_Paper_Demo_dataset\\Result3D\\"; 
stackB = "C:\\Users\\Kedar\\Desktop\\3D_Paper_Demo_dataset\\B-1\\"; 
output = "C:\\Users\\Kedar\\Desktop\\3D_Paper_Demo_dataset\\Result3D\\B1"; // output path + filename
out_dir = "C:\\Users\\Kedar\\Desktop\\3D_Paper_Demo_dataset\\Result3D\\";   // output path

display_stack = 1;


//Stack A fixed, stack B is translated/rotated


list1 = getFileList(stackA);
list2 = getFileList(stackB);


// Use Blue channel for alignment
//newImage("Untitled", "8-bit Black", 400, 400, 1);
open(stackA + list1[ list1.length - 2 ]);
rename("A");
run("Smooth");
//run("Copy");
//selectWindow("Untitled");
//run("Paste");
//titleA = "A";
//rename(titleA);
idA = getImageID();
//selectWindow("A0");
//close();

newImage("Untitled", "8-bit Black", 400, 400, 1);
open(stackB + list2[ 1 ]);
rename("B0");
run("Subtract Background...", "rolling=50");
run("Smooth");
run("Copy");
selectWindow("Untitled");
run("Paste");
titleB = "B";
rename(titleB);
idB = getImageID();
selectWindow("B0");
close();

run("Images to Stack", "name=AB title=[] use keep");
idAB = getImageID();

run("Make Montage...", "columns=2 rows=1 scale=1 first=1 last=2 increment=1 border=0 font=12 label");
idMontage = getImageID();


runcode = getBoolean("Bottom slice of stack A and top slice of stack B are shown. Continue ?");

selectImage(idAB);
close();
selectImage(idMontage);
close();

if (runcode == 1) {

width = getWidth();
height = getHeight();

//selectWindow("A");
//run("Auto Threshold", "method=MinError(I) ignore_black white");
//selectWindow("B");
//run("Auto Threshold", "method=MinError(I) ignore_black white");


run("TurboReg ",
	"-align " // Register the two images that we have just prepared.
	+ "-window " + "B" + " "// Source (window reference).
	+ "0 0 " + (width - 1) + " " + (height - 1) + " " // No cropping.
	+ "-window " + "A" + " "// Target (file reference).
	+ "0 0 " + (width - 1) + " " + (height - 1) + " " // No cropping.
	+ "-affine " // This corresponds to rotation and translation.
	+ (width / 2) + " " + (height / 2) + " " // Source translation landmark.
	+ (width / 2) + " " + (height / 2) + " " // Target translation landmark.
	+ "0 " + (height / 2) + " " // Source first rotation landmark.
	+ "0 " + (height / 2) + " " // Target first rotation landmark.
	+ (width - 1) + " " + (height / 2) + " " // Source second rotation landmark.
	+ (width - 1) + " " + (height / 2) + " " // Target second rotation landmark.
	+ "-showOutput");



x0s = getResult("sourceX", 0); 
y0s = getResult("sourceY", 0);
x0t = getResult("targetX", 0);
y0t = getResult("targetY", 0);
x1s = getResult("sourceX", 1); 
y1s = getResult("sourceY", 1);
x1t = getResult("targetX", 1);
y1t = getResult("targetY", 1);
x2s = getResult("sourceX", 2); 
y2s = getResult("sourceY", 2);
x2t = getResult("targetX", 2);
y2t = getResult("targetY", 2);

dx = x0t - x0s;
dy = y0t - y0s;
translation = sqrt(dx * dx + dy * dy); // Amount of translation, in pixel units.
dxs = x2s - x1s;
dys = y2s - y1s;
sourceAngle = atan2(dys, dxs);
dxt = x2t - x1t;
dyt = y2t - y1t;
targetAngle = atan2(dyt, dxt);
rot_angle = (targetAngle - sourceAngle)*180/PI; // Amount of rotation, in  degrees.

selectWindow("Output");
close();




// Now apply rotation and translation to all images in stack B
for (i = 0; i < list2.length; i++){
	zidx = floor(i/3) + 1;
	c = (i+1) - floor( (i+1)/3) * 3;
	cidx = c;
	if(c == 0) {cidx = 3;}
	newImage("Untitled", "8-bit Black", 400, 400, 1);
	open(stackB + list2[i]);
	run("Copy");
	selectWindow("Untitled");
	run("Paste");
	rename("NewImg");
        run("Select All");
        
	
	run("Rotate... ", "angle=" + rot_angle + " grid=1 interpolation=Bicubic");
        run("Translate...", "x=" + dx + " y=" + dy + " interpolation=Bicubic");	
        //saveAs("Tiff", output + "_z" + zidx + "_c" + cidx);
        idx = i+1;
        if(idx < 10){name_idx = "0" + idx;}
        if(idx >= 10){name_idx = idx;} 

// Blend with bottom slice of stack A if zidx <= 5
        if( zidx <= 3){
                 list = getFileList(out_dir);
                 open(out_dir + list[ list.length - 3]);
                 rename("GR");
                 open(out_dir + list[ list.length - 2]);
                 rename("BL");
                 open(out_dir + list[ list.length - 1]);
                 rename("MG");
        	beta = zidx*0.3; 
        	alpha = 1 - beta;
        	
        	if (cidx == 1){
        		selectWindow("GR");
        		run("Multiply...", "value=" + alpha);
        		selectWindow("NewImg");
        		run("Multiply...", "value=" + beta);
        		imageCalculator("Add", "NewImg","GR");
        		selectWindow("GR");
        		run("Multiply...", "value=" + 1/alpha);
        		
        	}

                 if (cidx == 2){
        		selectWindow("BL");
        		run("Multiply...", "value=" + alpha);
        		selectWindow("NewImg");
        		run("Multiply...", "value=" + beta);
        		imageCalculator("Add", "NewImg","BL");
        		selectWindow("BL");
        		run("Multiply...", "value=" + 1/alpha);
        		
        	}

        	if (cidx == 3){
        		selectWindow("MG");
        		run("Multiply...", "value=" + alpha);
        		selectWindow("NewImg");
        		run("Multiply...", "value=" + beta);
        		imageCalculator("Add", "NewImg","MG");
        		selectWindow("MG");
        		run("Multiply...", "value=" + 1/alpha);
        		
        	}
        	selectWindow("GR"); close();
        	selectWindow("BL"); close();
        	selectWindow("MG"); close();
        }

        //selectWindow("NewImg");
        //getRawStatistics(nPixels, mean, d1, d2, d3, d4);
	//run("Divide...", "value=" + mean);
	//run("Multiply...", "value=" + 16);
	//run("Subtract Background...", "rolling=50");
        saveAs("Tiff", output + name_idx); 
        close();
        close();
}
selectImage(idA); close();
selectImage(idB); close();


if(display_stack == 1){
// Display and Movie

list = getFileList(out_dir);
Nz = floor(list.length/3);
first_file = (out_dir + list[0]);
run("Image Sequence...", "open=" + out_dir + " number=" + list.length + " starting=1 increment=1 scale=100 file=[] or=[] sort");
id_out = getImageID();
selectImage(id_out);
run("Stack to Hyperstack...", "order=xyczt(default) channels=3 slices=" + Nz + " frames=1 display=Composite");
run("Channels Tool...");
run("Green");
Stack.setChannel(2);
run("Blue");
Stack.setChannel(3);
run("Magenta");

run("3D Viewer");
call("ij3d.ImageJ3DViewer.setCoordinateSystem", "false");
call("ij3d.ImageJ3DViewer.add", "Result3D", "None", "Result3D", "0", "true", "true", "true", "2", "0");


}

}